package Gamefile
{
   import fl.transitions.Tween;
   import fl.transitions.TweenEvent;
   import fl.transitions.easing.*;
   import flash.display.DisplayObject;
   import flash.display.MovieClip;
   import flash.display.SimpleButton;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.filters.GlowFilter;
   
   public class Animal
   {
       
      
      private var sprayFirst:Boolean;
      
      private var _chooseUpBtn_:SimpleButton;
      
      public var sound:String;
      
      private var _chooseDownBtn_:SimpleButton;
      
      private var animalFilter:GlowFilter;
      
      public var _animalBtnMC_:MovieClip;
      
      private var PARENT:MovieClip;
      
      private var tweenDown:Tween;
      
      private var _chickBtn_:SimpleButton;
      
      private var helpActionAnimal:MovieClip;
      
      private var _catBtn_:SimpleButton;
      
      private var _snake_:SimpleButton;
      
      private var _flamingoBtn_:SimpleButton;
      
      private var _mouseBtn_:MovieClip;
      
      private var _whaleBtn_:SimpleButton;
      
      public var animalDownFrame:int;
      
      private var actionAnimal:MovieClip;
      
      private var previousAnimal:SimpleButton;
      
      public var animalType:int;
      
      private var _llamaBtn_:MovieClip;
      
      private var movingFlag:Boolean;
      
      public var helpMovie:MovieClip;
      
      private var _hippoBtn_:SimpleButton;
      
      private var chooseAnimal:SimpleButton;
      
      private var tweenUp:Tween;
      
      private var tweenFlag:int;
      
      private var _pandaBtn_:SimpleButton;
      
      public function Animal(param1:MovieClip)
      {
         super();
         initAnimal(param1);
      }
      
      private function initProperty() : *
      {
         animalType = 0;
         animalFilter = new GlowFilter(16776960,1,10,10,10,1,false,false);
         sprayFirst = true;
         movingFlag = false;
         tweenFlag = 0;
         getChooseAnimal(_flamingoBtn_);
         animalType = 1;
         animalDownFrame = 5;
         sound = "_Flamingo_S_";
      }
      
      public function animalGlowFilter(param1:DisplayObject) : *
      {
         clearBtnFilters();
         param1.filters = [animalFilter];
      }
      
      public function outputHelpAnimal() : SimpleButton
      {
         return _catBtn_;
      }
      
      public function showHelpSprayMovie(param1:int, param2:int, param3:Number) : *
      {
         helpMovie = new _WhaleMovie_();
         _animalBtnMC_.addChild(helpMovie);
         helpMovie.x = param1;
         helpMovie.y = param2;
         helpMovie.scaleX = param3;
         helpMovie.scaleY = param3;
      }
      
      public function showActionAnimal(param1:MovieClip, param2:MovieClip, param3:int, param4:int) : *
      {
         param1.addChild(param2);
         param2.x = param3;
         param2.y = param4;
      }
      
      private function mouseIsOut(param1:MouseEvent) : *
      {
         PARENT.dispatchEvent(new Event("mouseIsOut",true));
      }
      
      public function returnActionAnimal() : MovieClip
      {
         return actionAnimal;
      }
      
      public function delHelpMovie() : *
      {
         if(helpMovie != null)
         {
            helpMovie.parent.removeChild(helpMovie);
            helpMovie = null;
         }
      }
      
      public function showHelpRepealMovie(param1:int, param2:int, param3:Number) : *
      {
         helpMovie = new _RepealMovie_();
         _animalBtnMC_.addChild(helpMovie);
         helpMovie.x = param1;
         helpMovie.y = param2;
         helpMovie.scaleX = param3;
         helpMovie.scaleY = param3;
      }
      
      private function initAnimal(param1:MovieClip) : *
      {
         PARENT = param1;
         initElement();
         initEvent();
         initProperty();
      }
      
      public function showHelpRepealAllMovie(param1:int, param2:int, param3:Number) : *
      {
         helpMovie = new _RepealAllMovie_();
         _animalBtnMC_.addChild(helpMovie);
         helpMovie.x = param1;
         helpMovie.y = param2;
         helpMovie.scaleX = param3;
         helpMovie.scaleY = param3;
      }
      
      public function returnChooseAnimal() : SimpleButton
      {
         return chooseAnimal;
      }
      
      public function clearBtnFilters() : *
      {
         if(previousAnimal != null)
         {
            previousAnimal.filters = [];
         }
         _catBtn_.filters = [];
         _whaleBtn_.filters = [];
      }
      
      private function mouseIsOver(param1:MouseEvent) : *
      {
         if(movingFlag == true)
         {
            PARENT.dispatchEvent(new Event("mouseIsNotEnabled",true));
         }
         else
         {
            SoundsManager.playSound("_GameMouseOver_");
            PARENT.dispatchEvent(new Event("mouseIsOver",true));
         }
      }
      
      public function outputHelpSprayAnimal() : SimpleButton
      {
         return _whaleBtn_;
      }
      
      private function getActionAnimal(param1:SimpleButton) : *
      {
         switch(param1.name)
         {
            case "FlamingoBtn":
               actionAnimal = new _ActionFlamingo_();
               break;
            case "PandaBtn":
               actionAnimal = new _ActionPanda_();
               break;
            case "ChickBtn":
               actionAnimal = new _ActionChick_();
               break;
            case "CatBtn":
               actionAnimal = new _ActionCat_();
               break;
            case "HippoBtn":
               actionAnimal = new _ActionHippo_();
               break;
            case "WhaleBtn":
            case "LlamaBtn":
            case "MouseBtn":
               break;
            case "SnakeBtn":
               actionAnimal = new _ActionSnake_();
         }
      }
      
      public function getMovingFlag(param1:Boolean) : *
      {
         movingFlag = param1;
      }
      
      private function initElement() : *
      {
         _animalBtnMC_ = PARENT.getChildByName("AnimalBtnMC") as MovieClip;
         _flamingoBtn_ = _animalBtnMC_.getChildByName("FlamingoBtn") as SimpleButton;
         _pandaBtn_ = _animalBtnMC_.getChildByName("PandaBtn") as SimpleButton;
         _chickBtn_ = _animalBtnMC_.getChildByName("ChickBtn") as SimpleButton;
         _catBtn_ = _animalBtnMC_.getChildByName("CatBtn") as SimpleButton;
         _hippoBtn_ = _animalBtnMC_.getChildByName("HippoBtn") as SimpleButton;
         _whaleBtn_ = PARENT.getChildByName("WhaleBtn") as SimpleButton;
         _snake_ = _animalBtnMC_.getChildByName("SnakeBtn") as SimpleButton;
      }
      
      public function showHelpAnimalMovie(param1:int, param2:int, param3:Number) : *
      {
         helpMovie = new _CatMovie_();
         _animalBtnMC_.addChild(helpMovie);
         helpMovie.x = param1;
         helpMovie.y = param2;
         helpMovie.scaleX = param3;
         helpMovie.scaleY = param3;
      }
      
      public function outputHelpActionAnimal() : MovieClip
      {
         helpActionAnimal = new _ActionCat_();
         return helpActionAnimal;
      }
      
      public function showHelpPencilMovie(param1:int, param2:int, param3:Number) : *
      {
         helpMovie = new _PencilMovie_();
         _animalBtnMC_.addChild(helpMovie);
         helpMovie.x = param1;
         helpMovie.y = param2;
         helpMovie.scaleX = param3;
         helpMovie.scaleY = param3;
      }
      
      public function delEvent() : *
      {
         _flamingoBtn_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _pandaBtn_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _chickBtn_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _catBtn_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _hippoBtn_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _whaleBtn_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _flamingoBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _pandaBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _chickBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _catBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _hippoBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _whaleBtn_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _snake_.removeEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _flamingoBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _pandaBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _chickBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _catBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _hippoBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _whaleBtn_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _snake_.removeEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _snake_.removeEventListener(MouseEvent.CLICK,chooseTheAnimal);
      }
      
      public function outPutBtnMCY() : int
      {
         return _animalBtnMC_.y;
      }
      
      private function getChooseAnimal(param1:SimpleButton) : *
      {
         chooseAnimal = param1;
         animalGlowFilter(param1);
         previousAnimal = param1;
         getActionAnimal(param1);
      }
      
      private function initEvent() : *
      {
         _flamingoBtn_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _pandaBtn_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _chickBtn_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _catBtn_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _hippoBtn_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _whaleBtn_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
         _flamingoBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _pandaBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _chickBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _catBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _hippoBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _whaleBtn_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _snake_.addEventListener(MouseEvent.MOUSE_OVER,mouseIsOver);
         _flamingoBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _pandaBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _chickBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _catBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _hippoBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _whaleBtn_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _snake_.addEventListener(MouseEvent.MOUSE_OUT,mouseIsOut);
         _snake_.addEventListener(MouseEvent.CLICK,chooseTheAnimal);
      }
      
      private function tweenEnd(param1:TweenEvent) : *
      {
         if(tweenFlag == 1)
         {
            tweenUp.removeEventListener(TweenEvent.MOTION_FINISH,tweenEnd);
         }
         else if(tweenFlag == 2)
         {
            tweenDown.removeEventListener(TweenEvent.MOTION_FINISH,tweenEnd);
         }
         tweenFlag = 0;
      }
      
      private function chooseTheAnimal(param1:MouseEvent) : *
      {
         if(movingFlag == false)
         {
            delActionAnimal();
            switch(param1.target.name)
            {
               case "FlamingoBtn":
                  SoundsManager.playSound("_Flamingo_S_");
                  sound = "_Flamingo_S_";
                  getChooseAnimal(_flamingoBtn_);
                  animalType = 1;
                  sprayFirst = true;
                  animalDownFrame = 5;
                  break;
               case "PandaBtn":
                  SoundsManager.playSound("_Panda_S_");
                  sound = "_Panda_S_";
                  getChooseAnimal(_pandaBtn_);
                  animalType = 1;
                  sprayFirst = true;
                  animalDownFrame = 6;
                  break;
               case "ChickBtn":
                  SoundsManager.playSound("_Chick_S_");
                  sound = "_Chick_S_";
                  getChooseAnimal(_chickBtn_);
                  animalType = 1;
                  sprayFirst = true;
                  animalDownFrame = 7;
                  break;
               case "CatBtn":
                  SoundsManager.playSound("_Cat_S_");
                  sound = "_Cat_S_";
                  getChooseAnimal(_catBtn_);
                  animalType = 1;
                  sprayFirst = true;
                  animalDownFrame = 8;
                  break;
               case "HippoBtn":
                  SoundsManager.playSound("_Hippo_S_");
                  sound = "_Hippo_S_";
                  getChooseAnimal(_hippoBtn_);
                  animalType = 1;
                  sprayFirst = true;
                  animalDownFrame = 9;
                  break;
               case "WhaleBtn":
                  SoundsManager.playSound("_Whale_S_");
                  getChooseAnimal(_whaleBtn_);
                  animalType = 2;
                  animalDownFrame = 2;
                  if(sprayFirst == true)
                  {
                     sprayFirst = false;
                  }
                  else if(sprayFirst == false)
                  {
                     PARENT.dispatchEvent(new Event("changeSprayType",true));
                  }
                  break;
               case "LlamaBtn":
                  animalType = 3;
                  break;
               case "MouseBtn":
                  animalType = 4;
                  break;
               case "SnakeBtn":
                  SoundsManager.playSound("_Snake_S_");
                  sound = "_Snake_S_";
                  getChooseAnimal(_snake_);
                  animalType = 5;
                  sprayFirst = true;
                  animalDownFrame = 10;
            }
            PARENT.dispatchEvent(new Event("chooseTheAnimal",true));
         }
      }
      
      public function hideActionAnimal(param1:MovieClip) : *
      {
         param1.visible = false;
      }
      
      private function delActionAnimal() : *
      {
         if(actionAnimal != null)
         {
            actionAnimal.parent.removeChild(actionAnimal);
         }
      }
   }
}
